          nam       Kermit68K
          ttl       Commands keywords tables module

*         Kermit68K: source file K68CTB
*
* Author: Roberto Bagnara (Bagnara@Iboinfn.Bitnet),
* Bologna University, Physics Department, July 1987.
*
* All rights reserved to Bologna University, Italy.
*
* Permission is granted to any individual or institution
* to use, copy, or redistribute this software so long as
* it  is not  sold for  profit, provided  this copyright
* notice is retained.
*
* Modification History:
*
* Version  Date    Who              Comments
*
* 1.0.00   870701  Roberto Bagnara  First official release

          use       DefsFile

Edition   equ       0
          psect     K68CmdTables,0,0,Edition,0,0

* Values associated with top-level commands.

CmdBYE    EQU       0                  BYE
CmdCONCT  EQU       1                  CONNECT
CmdCOPY   EQU       2                  COPY
CmdCWD    EQU       3                  CWD (Change Working Directory)
CmdDEFIN  EQU       4                  DEFINE (a command macro)
CmdDELET  EQU       5                  (Local) DELETE
CmdDIR    EQU       6                  (Local) DIRECTORY
CmdECHO   EQU       7                  ECHO
CmdEXIT   EQU       8                  EXIT
CmdFINSH  EQU       9                  FINISH
CmdGET    EQU      10                  GET
CmdHELP   EQU      11                  HELP
CmdLIST   EQU      12                  LIST
CmdPRINT  EQU      13                  (Local) PRINT
CmdRCEIV  EQU      14                  RECEIVE
CmdREMOT  EQU      15                  REMOTE
CmdRENAM  EQU      16                  (Local) RENAME
CmdSEND   EQU      17                  SEND
CmdSET    EQU      18                  SET
CmdSHOW   EQU      19                  SHOW
CmdSPACE  EQU      20                  (Local) SPACE
CmdSTATS  EQU      21                  STATISTICS
CmdTAKE   EQU      22                  TAKE
CmdTYPE   EQU      23                  (Local) TYPE
CmdCOMMN  EQU      24                  Comment
CmdSYSC   EQU      25                  System command

* Top-level commands string table.

CmdTable: DC.B      CmdBYE,"BYE",Asc_Nul
          DC.B      CmdCONCT,"C",Asc_Nul
          DC.B      CmdCONCT,"CONNECT",Asc_Nul
          DC.B      CmdCOPY,"COPY",Asc_Nul
          DC.B      CmdCWD,"CWD",Asc_Nul
          DC.B      CmdDEFIN,"DEFINE",Asc_Nul
          DC.B      CmdDELET,"DELETE",Asc_Nul
          DC.B      CmdDIR,"DIRECTORY",Asc_Nul
          DC.B      CmdECHO,"ECHO",Asc_Nul
          DC.B      CmdEXIT,"EXIT",Asc_Nul
          DC.B      CmdFINSH,"FINISH",Asc_Nul
          DC.B      CmdGET,"GET",Asc_Nul
          DC.B      CmdHELP,"HELP",Asc_Nul
          DC.B      CmdLIST,"LIST",Asc_Nul
          DC.B      CmdPRINT,"PRINT",Asc_Nul
          DC.B      CmdEXIT,"QUIT",Asc_Nul
          DC.B      CmdRCEIV,"R",Asc_Nul
          DC.B      CmdRCEIV,"RECEIVE",Asc_Nul
          DC.B      CmdREMOT,"REMOTE",Asc_Nul
          DC.B      CmdRENAM,"RENAME",Asc_Nul
          DC.B      CmdSEND,"S",Asc_Nul
          DC.B      CmdSEND,"SEND",Asc_Nul
          DC.B      CmdSET,"SET",Asc_Nul
          DC.B      CmdSHOW,"SHOW",Asc_Nul
          DC.B      CmdSPACE,"SPACE",Asc_Nul
          DC.B      CmdSTATS,"STATISTICS",Asc_Nul
          DC.B      CmdTAKE,"TAKE",Asc_Nul
          DC.B      CmdTYPE,"TYPE",Asc_Nul
          DC.B      CmdCOMMN,"%",Asc_Nul
          DC.B      CmdSYSC,"!",Asc_Nul
          DC.B      -1
          DC.B      "command verb",Asc_Nul

* Top-level commands jump table.

DoCmdTab: DC.W      DoBYE-DoCmdTab     CmdBYE
          DC.W      DoCONN-DoCmdTab    CmdCONCT
          DC.W      DoCOPY-DoCmdTab    CmdCOPY
          DC.W      DoCWD-DoCmdTab     CmdCWD
          DC.W      DoDEFN-DoCmdTab   CmdDEFIN
          DC.W      DoDELETE-DoCmdTab  CmdDELET
          DC.W      DoDIR-DoCmdTab     CmdDIR
          DC.W      DoECHO-DoCmdTab    CmdECHO
          DC.W      DoEXIT-DoCmdTab    CmdEXIT
          DC.W      DoFINISH-DoCmdTab  CmdFINSH
          DC.W      DoGET-DoCmdTab     CmdGET
          DC.W      DoHELP-DoCmdTab    CmdHELP
          DC.W      DoLIST-DoCmdTab    CmdLIST
          DC.W      DoPRINT-DoCmdTab   CmdPRINT
          DC.W      DoRECVE-DoCmdTab   CmdRCEIV
          DC.W      DoREMOT-DoCmdTab   CmdREMOT
          DC.W      DoRENAME-DoCmdTab  CmdRENAM
          DC.W      DoSEND-DoCmdTab    CmdSEND
          DC.W      DoSET-DoCmdTab     CmdSET
          DC.W      DoSHOW-DoCmdTab    CmdSHOW
          DC.W      DoSPACE-DoCmdTab   CmdSPACE
          DC.W      DoSTATS-DoCmdTab   CmdSTATS
          DC.W      DoTAKE-DoCmdTab    CmdTAKE
          DC.W      DoTYPE-DoCmdTab    CmdTYPE
          DC.W      DoCOMMNT-DoCmdTab  CmdCOMMN
          DC.W      DoSYSCMD-DoCmdTab  CmdSYSC

* Values associated with SET command qualifiers.

SetBCHKT  EQU       0                  Block check type
SetDELAY  EQU       1                  Delay
SetDUPLX  EQU       2                  Duplex
SetESCAP  EQU       3                  Escape character
SetFILE   EQU       4                  File Parameters
SetFLOW   EQU       5                  Flow Control
SetHNDSH  EQU       6                  Handshake
SetINCFD  EQU       7                  Incomplete File Disposition
SetLINE   EQU       8                  Communication line to use
SetPRITY  EQU       9                  Parity
SetPRMPT  EQU      10                  Program prompt string
SetRETRY  EQU      11                  Retry limits
SetSPEED  EQU      12                  Line speed (baud rate)
SetSEND   EQU      13                  SEND parameters
SetRCEIV  EQU      14                  RECEIVE parameters

* SET command qualifiers string table.

SETTable: DC.B      SetSPEED,"BAUD",Asc_Nul
          DC.B      SetBCHKT,"BLOCK_CHECK_TYPE",Asc_Nul
          DC.B      SetDELAY,"DELAY",Asc_Nul
          DC.B      SetDUPLX,"DUPLEX",Asc_Nul
          DC.B      SetESCAP,"ESCAPE_CHARACTER",Asc_Nul
          DC.B      SetFILE,"FILE",Asc_Nul
          DC.B      SetFLOW,"FLOW_CONTROL",Asc_Nul
          DC.B      SetHNDSH,"HANDSHAKE",Asc_Nul
          DC.B      SetINCFD,"INCOMPLETE_FILE_DISPOSITION",Asc_Nul
          DC.B      SetLINE,"LINE",Asc_Nul
          DC.B      SetPRITY,"PARITY",Asc_Nul
          DC.B      SetPRMPT,"PROMPT",Asc_Nul
          DC.B      SetRCEIV,"RECEIVE",Asc_Nul
          DC.B      SetRETRY,"RETRY",Asc_Nul
          DC.B      SetSEND,"SEND",Asc_Nul
          DC.B      SetSPEED,"SPEED",Asc_Nul
          DC.B      -1
          DC.B      "SET option or parameter",Asc_Nul

* SET command qualifiers jump table.

DoSetTab: DC.W      DoStBCT-DoSetTab   SetBCHKT
          DC.W      DoStDLAY-DoSetTab  SetDELAY
          DC.W      DoStDUP-DoSetTab   SetDUPLX
          DC.W      DoSetESC-DoSetTab  SetESCAP
          DC.W      DoSFILE-DoSetTab   SetFILE
          DC.W      DoStFLW-DoSetTab   SetFLOW
          DC.W      DoStHND-DoSetTab   SetHNDSH
          DC.W      DoStIFD-DoSetTab   SetINCFD
          DC.W      DoStLIN-DoSetTab   SetLINE
          DC.W      DoStPAR-DoSetTab   SetPRITY
          DC.W      DoStPRM-DoSetTab   SetPRMPT
          DC.W      DoSRTRY-DoSetTab   SetRETRY
          DC.W      DoStSPE-DoSetTab   SetSPEED
          DC.W      DoSSEND-DoSetTab   SetSEND
          DC.W      DoSRECV-DoSetTab   SetRCEIV

* Values associated with SET SEND/RECEIVE parameters.

SetEOL    EQU       0                  End-Of-Line (packet terminator)
SetMARKR  EQU       1                  Start of Packet marker
SetMXPLN  EQU       2                  Maximum packet length to send
SetNPAD   EQU       3                  Amount of padding
SetPDCHR  EQU       4                  Pad character
SetTMOUT  EQU       5                  Timeout interval

* SET SEND/RECEIVE parameters string table.

SSRTable: DC.B      SetEOL,"END_OF_LINE",Asc_Nul
          DC.B      SetMARKR,"MARKER",Asc_Nul
          DC.B      SetMXPLN,"PACKET_LENGTH",Asc_Nul
          DC.B      SetNPAD,"PADDING",Asc_Nul
          DC.B      SetPDCHR,"PAD_CHARACTER",Asc_Nul
          DC.B      SetTMOUT,"TIMEOUT",Asc_Nul
          DC.B      -1
          DC.B      "SET SEND/RECEIVE parameter",Asc_Nul

* SET SEND parameters jump table.

DoSetSTb: DC.W      DoStSEOL-DoSetSTb  SetEOL
          DC.W      DoStSMrk-DoSetSTb  SetMARKR
          DC.W      DoStSMPS-DoSetSTb  SetMXPLN
          DC.W      DoStSPdN-DoSetSTb  SetNPAD
          DC.W      DoStSPdC-DoSetSTb  SetPDCHR
          DC.W      DoStSTIM-DoSetSTb  SetTMOUT

* SET RECEIVE parameters jump table.

DoSetRTb: DC.W      DoStREOL-DoSetRTb  SetEOL
          DC.W      DoStRMrk-DoSetRTb  SetMARKR
          DC.W      DoStRMPS-DoSetRTb  SetMXPLN
          DC.W      DoStRPdN-DoSetRTb  SetNPAD
          DC.W      DoStRPdC-DoSetRTb  SetPDCHR
          DC.W      DoStRTIM-DoSetRTb  SetTMOUT

* Values associated with REMOTE command qualifiers.

RemCOPY   EQU       0                  Copy
RemCWD    EQU       1                  Change Working Directory
RemDELET  EQU       2                  Delete
RemDIR    EQU       3                  Directory
RemHELP   EQU       4                  Help
RemHOST   EQU       5                  Host
RemKRMIT  EQU       6                  Kermit
RemPRINT  EQU       7                  Print
RemRENAM  EQU       8                  Rename
RemSET    EQU       9                  SET
RemSPACE  EQU      10                  Space
RemSUBMT  EQU      11                  Submit
RemTYPE   EQU      12                  Type
RemWHO    EQU      13                  Who

* REMOTE command qualifiers string table.

REMTable: DC.B      RemCOPY,"COPY",Asc_Nul
          DC.B      RemCWD,"CWD",Asc_Nul
          DC.B      RemDELET,"DELETE",Asc_Nul
          DC.B      RemDIR,"DIRECTORY",Asc_Nul
          DC.B      RemHELP,"HELP",Asc_Nul
          DC.B      RemHOST,"HOST",Asc_Nul
          DC.B      RemKRMIT,"KERMIT",Asc_Nul
          DC.B      RemPRINT,"PRINT",Asc_Nul
          DC.B      RemRENAM,"RENAME",Asc_Nul
          DC.B      RemSET,"SET",Asc_Nul
          DC.B      RemSPACE,"SPACE",Asc_Nul
          DC.B      RemSUBMT,"SUBMIT",Asc_Nul
          DC.B      RemTYPE,"TYPE",Asc_Nul
          DC.B      RemWHO,"WHO",Asc_Nul
          DC.B      -1
          DC.B      "REMOTE Kermit server command",Asc_Nul

* REMOTE command qualifiers jump table.

DoRemTab: DC.W      DoRemCOP-DoRemTab  RemCOPY
          DC.W      DoRmCWD-DoRemTab   RemCWD
          DC.W      DoRemDEL-DoRemTab  RemDELET
          DC.W      DoRmDIR-DoRemTab   RemDIR
          DC.W      DoRmHELP-DoRemTab  RemHELP
          DC.W      DoRemHOS-DoRemTab  RemHOST
          DC.W      DoRemKER-DoRemTab  RemKRMIT
          DC.W      DoRemPRI-DoRemTab  RemPRINT
          DC.W      DoRemREN-DoRemTab  RemRENAM
          DC.W      DoRemSET-DoRemTab  RemSET
          DC.W      DoRmSPA-DoRemTab   RemSPACE
          DC.W      DoRemSUB-DoRemTab  RemSUBMT
          DC.W      DoRemTYP-DoRemTab  RemTYPE
          DC.W      DoRmWHO-DoRemTab   RemWHO

* Values associated with SHOW command qualifiers.

ShoPARAM  EQU       0                  Parameters
ShoVERS   EQU       1                  Version

* SHOW command qualifiers table.

SHOWTabl: DC.B      ShoPARAM,"PARAMETERS",Asc_Nul
          DC.B      ShoVERS,"VERSION",Asc_Nul
          DC.B      -1
          DC.B      "SHOW option",Asc_Nul

* SHOW command options jump table.

DoShoTab: DC.W      DoShoP-DoShoTab    ShoPARAM
          DC.W      DoShoVer-DoShoTab  ShoVERS

* Values associated with SET FILE command parameters.

SetFDISP  EQU       0                  File display
SetFNAME  EQU       1                  File naming
SetFTYPE  EQU       2                  File type
SetFWARN  EQU       3                  File warning

* SET FILE command parameters table.

SFILTabl: DC.B      SetFDISP,"DISPLAY",Asc_Nul
          DC.B      SetFNAME,"NAMES",Asc_Nul
          DC.B      SetFTYPE,"TYPE",Asc_Nul
          DC.B      SetFWARN,"WARNING",Asc_Nul
          DC.B      -1
          DC.B      "file parameter",Asc_Nul

* SET FILE command parameters jump table.

DoSFlTab: DC.W      DoStFDs-DoSFlTab   SetFDISP
          DC.W      DoStFNm-DoSFlTab   SetFNAME
          DC.W      DoStFTp-DoSFlTab   SetFTYPE
          DC.W      DoStFWn-DoSFlTab   SetFWARN

* Values associated with SET RETRY command parameters.

SetRtINI  EQU       0                  Set retry initial connection packet
SetRtPAK  EQU       1                  Set retry normal packet

* SET RETRY command parameters table.

SRETTabl: DC.B      SetRtINI,"INITIAL_CONNECTION",Asc_Nul
          DC.B      SetRtPAK,"PACKET",Asc_Nul
          DC.B      -1
          DC.B      "retry parameter",Asc_Nul

* SET RETRY command parameters jump table.

DoSRtTab: DC.W      DoSetRtI-DoSRtTab  SetRtINI
          DC.W      DoSetRtP-DoSRtTab  SetRtPAK

* On/Off specification keyword table.

OnOfTabl: DC.B      0,"FALSE",Asc_Nul
          DC.B      0,"OFF",Asc_Nul
          DC.B      0,"NO",Asc_Nul
          DC.B      0,"0",Asc_Nul
          DC.B      1,"TRUE",Asc_Nul
          DC.B      1,"ON",Asc_Nul
          DC.B      1,"YES",Asc_Nul
          DC.B      1,"1",Asc_Nul
          DC.B      -1
          DC.B      "on/off specification",Asc_Nul

* Block check specification keyword table.

BlCkTabl: DC.B      1,"1",Asc_Nul
          DC.B      1,"ONE",Asc_Nul
          DC.B      2,"2",Asc_Nul
          DC.B      2,"TWO",Asc_Nul
          DC.B      3,"3",Asc_Nul
          DC.B      3,"THREE",Asc_Nul
          DC.B      -1
          DC.B      "block check type specification",Asc_Nul

* Parity specification keyword table.

ParTable: DC.B      0,"NONE",Asc_Nul
          DC.B      "O","ODD",Asc_Nul
          DC.B      "E","EVEN",Asc_Nul
          DC.B      "M","MARK",Asc_Nul
          DC.B      "S","SPACE",Asc_Nul
          DC.B      -1
          DC.B      "parity specification",Asc_Nul

* Incomplete file disposition keyword table.

IFlDTabl: DC.B      0,"DISCARD",Asc_Nul
          DC.B      1,"KEEP",Asc_Nul
          DC.B      -1
          DC.B      "incomplete file disposition",Asc_Nul

* File type specification keyword table.

FTypTabl: DC.B      0,"TEXT",Asc_Nul
          DC.B      1,"BINARY",Asc_Nul
          DC.B      -1
          DC.B      "file type specification",Asc_Nul

* File naming specification keyword table.

FNamTabl: DC.B      0,"LITERAL",Asc_Nul
          DC.B      1,"CONVERTED",Asc_Nul
          DC.B      -1
          DC.B      "file naming specification",Asc_Nul

* Flow control specification keyword table.

FlowTabl: DC.B      0,"NONE",Asc_Nul
          DC.B      1,"XON/XOFF",Asc_Nul
          DC.B      -1
          DC.B      "flow control specification",Asc_Nul

* Duplex specification keyword table.

DuplTabl: DC.B      0,"FULL",Asc_Nul
          DC.B      1,"HALF",Asc_Nul
          DC.B      -1
          DC.B      "duplex specification",Asc_Nul

* Handshake characters specification keyword table.

HandTabl: DC.B      0,"NONE",Asc_Nul
          DC.B      Asc_Bel,"BELL",Asc_Nul
          DC.B      Asc_LF,"LF",Asc_Nul
          DC.B      Asc_CR,"CR",Asc_Nul
          DC.B      Asc_DC1,"XON",Asc_Nul
          DC.B      Asc_DC3,"XOFF",Asc_Nul
          DC.B      Asc_Esc,"ESC",Asc_Nul
          DC.B      -1
          DC.B      "handshake character specification",Asc_Nul

          align                        Following code aligned on word boundary
          ends
          END
